﻿Imports System.ComponentModel
Imports System.Text

Public Class ContextMenuListView
    Public CurrentListView As New ListView

    Public Event CopySelectedItems_Clicked(sender As ListView)
    Public Event CopyAll_Clicked(sender As ListView)

    Public Sub Show(SourceListView As ListView, e As MouseEventArgs)
        If e.Button = MouseButtons.Right Then
            CurrentListView = SourceListView
            If CurrentListView.Items.Count = 0 Then Exit Sub
            ContMenu.Show(GetMousePosition)
        End If
    End Sub


    Private Sub ContMenu_ListView_CopyAll_Click(sender As Object, e As EventArgs) _
        Handles ContMenu_ListView_CopyAll.Click
        Dim BufStr As String = Get_AllListViewText()

        If BufStr = "" Then
            MsgBox("No content to be copied!", MsgBoxStyle.OkOnly, "Copy")
        Else
            Clipboard.SetText(BufStr)
            RaiseEvent CopyAll_Clicked(CurrentListView)
        End If
    End Sub

    Private Sub ContMenu_ListView_CopySelectedItems_Click(sender As Object, e As EventArgs) _
        Handles ContMenu_ListView_CopySelectedItems.Click
        Dim BufStr As String = Get_SelectedListViewText()

        If BufStr = "" Then
            MsgBox("No content to be copied!", MsgBoxStyle.OkOnly, "Copy")
        Else
            Clipboard.SetText(BufStr)
            RaiseEvent CopySelectedItems_Clicked(CurrentListView)
        End If
    End Sub

    Public Function Get_SelectedListViewText() As String

        Dim BufStr As New StringBuilder
        Dim UpperIndex As Integer = CurrentListView.SelectedItems.Count - 1


        For q As Integer = 0 To UpperIndex
            For w As Integer = 0 To 2
                BufStr.Append(CurrentListView.SelectedItems(q).SubItems(w).Text)
                If w = 2 Then
                    BufStr.Append(vbCrLf)
                Else
                    BufStr.Append(vbTab)
                End If
            Next
        Next

        If BufStr.Length = 0 Then
            Return ""
        Else
            Return BufStr.ToString
        End If
    End Function


    Public Function Get_AllListViewText() As String
        Dim BufStr As New StringBuilder
        Dim UpperIndex As Integer = CurrentListView.Items.Count - 1


        For q As Integer = 0 To UpperIndex
            For w As Integer = 0 To 2
                BufStr.Append(CurrentListView.Items(q).SubItems(w).Text)
                If w = 2 Then
                    BufStr.Append(vbCrLf)
                Else
                    BufStr.Append(vbTab)
                End If
            Next
        Next

        If BufStr.Length = 0 Then
            Return ""
        Else
            Return BufStr.ToString
        End If
    End Function

    Private Sub ContMenu_Opening(sender As Object, e As CancelEventArgs) Handles ContMenu.Opening
    End Sub
End Class
