﻿Imports System.IO

Public Class FileSystemEngine
    Public IsStopProcessing As Boolean = False
    Public Event ProcessingMessage(MsgStr As String)
    Public Event ProcessingStopped()


    Public Sub StopProcessing()
        IsStopProcessing = True
    End Sub


    Public Function IsFolder(TestPath As String)
        Return (File.GetAttributes(TestPath) And FileAttributes.Directory) = FileAttributes.Directory
    End Function


    Public Function LastModifiedDateStr(FileFullPath As String) As String
        If FileFullPath = "" Then Return ""

        If FileExists(FileFullPath) Then
            Return FileDateTime(FileFullPath).ToString
        Else
            Return ""
        End If
    End Function


    Public Function Get_AllFullFileNamesInFolder(FullPathFolderName As String) As String()
        Dim FullPathArray As String() =
                Directory.GetFiles(FullPathFolderName)


        For q As Integer = 0 To FullPathArray.GetUpperBound(0)
            FullPathArray(q) = FullPathArray(q)
        Next

        Return FullPathArray
    End Function


    Public Function Get_OnlyFileName_From_FullFileName(FullFileName As String) As String
        If FullFileName = "" Then Return ""

        Dim FileNameInfo As New FileInfo(FullFileName)

        Return FileNameInfo.Name
    End Function


    Public Function FileExists(FileFullPath As String) As Boolean
        If FileFullPath = "" Then Return False

        Dim f As New FileInfo(FileFullPath)
        Return f.Exists
    End Function


    Public Function FolderExists(FolderPath As String) As Boolean

        If FolderPath = "" Then Return False

        Dim f As New DirectoryInfo(FolderPath)
        Return f.Exists
    End Function


    Public Function Get_FileExtension_From_FullFileName(FullFileName As String) As String
        Return Path.GetExtension(Get_OnlyFileName_From_FullFileName(FullFileName))
    End Function


    Public Function Get_FilenameWithoutExtension_From_ShortFileName(ShortFileName As String) As String
        If ShortFileName = "" Then Return ""

        Return Path.GetFileNameWithoutExtension(ShortFileName)
    End Function
End Class
