﻿Imports System.ComponentModel
Imports System.IO
Imports System.Text
Imports unvell.ReoGrid

Public Class Frm_Tools
    Dim WithEvents MyFileLocal As New FileSystemEngine

    Dim ComputeStats_OutTable As New List(Of DailyMonthlyStatsFormat)
    Dim ReadOnly ComputeStats_OutTable_MaxLines As Integer = 20000
    Dim ReadOnly ComputeStats_SheetColUpperIndex As Integer = 18

    Dim ReadOnly ComputeStats_AllValues_UpperIndex As Integer =
                     ComputeStats_SheetColUpperIndex - 6


    Dim LastExportDataSaveTargetFolder As String = ""
    Dim ExportDate1, ExportDate2 As Date


    Public Structure StatsFormat
        Dim n As String
        Dim Mean As String
        Dim Stdev As String
        Dim Min As String
        Dim Max As String
        Dim PercentQ1 As String
        Dim PercentQ2 As String
        Dim PercentQ3 As String
        Dim Skewness As String
        Dim Kurtosis As String
        Dim Sum As String
        Dim CV As String
        Dim RMS As String
        Dim AllValues() As Single
    End Structure

    Public Structure DailyMonthlyStatsFormat
        Dim Filename As String
        Dim Variable As String
        Dim Feature As String
        Dim Year As String
        Dim Month As String
        Dim Day As String
        Dim n As String
        Dim Mean As String
        Dim Stdev As String
        Dim Min As String
        Dim Max As String
        Dim PercentQ1 As String
        Dim PercentQ2 As String
        Dim PercentQ3 As String
        Dim Skewness As String
        Dim Kurtosis As String
        Dim Sum As String
        Dim CV As String
        Dim RMS As String
        Dim AllValues() As Single
    End Structure

    Private Sub Me_Closing(sender As Object, e As CancelEventArgs) Handles MyBase.Closing
        If AllowFormCloseToEnd Then
        Else
            e.Cancel = True
            Me.Hide()
        End If
    End Sub

    Private Sub Frm_Process_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Combo_ExportData_FileFormat.Text = "txt"
        Combo_TimeWindowAveragingDay.Text = " 7 days"


        Grid_DailyStats.Anchor = AnchorStyle_AllDirection
        ListView_ExportDataErrors.Anchor = AnchorStyle_AllDirection

        ListView_ExportDataErrors.Anchor = AnchorStyle_TopBottomLeft
        FileDDBox_DailyStats.Anchor = AnchorStyle_TopBottomLeft

    End Sub


    Private Sub Cmd_ExportDataNow_Click(sender As Object, e As EventArgs) Handles Cmd_ExportDataNow.Click
        Cmd_ExportDataNow.Enabled = False
        ExportDataNow()
        AddAllToComputeStats()
        MsgBox("Export completed!", MsgBoxStyle.OkOnly, "Export")
        Cmd_ExportDataNow.Enabled = True
    End Sub


    Sub ExportDataNow()
        Dim CurrentVariable As String = ""
        Dim TargetFolder As String = Text_TargetExportDataSaveFolder.Text
        Dim FileExtension As String


        FileExtension = Combo_ExportData_FileFormat.Text

        Dim IsConfineDate As Boolean = Check_ConfineExportDate.Checked


        ListView_ExportDataErrors.Items.Clear()

        If MyFileLocal.FolderExists(TargetFolder) = False Then
            MsgBox("The destination folder is not found!",
                   MsgBoxStyle.Critical, "Error")
            Exit Sub
        End If


        ToolStrip_Status.Text = "Clearing the folder"
        StatusStrip.Refresh()

        If Check_EraseAllExportData.Checked Then
            Try
                Kill(TargetFolder + "\*.*")
            Catch
            End Try
        End If


        If IsConfineDate Then
            With Date_ExportDate1
                ExportDate1 = New Date(.Value.Year, .Value.Month, .Value.Day, 0, 0, 0)
            End With

            With Date_ExportDate2
                ExportDate2 = New Date(.Value.Year, .Value.Month, .Value.Day, 23, 59, 59)
            End With
        End If


        Dim isShowProgressWindow As Boolean = False

        With Frm_Chart
            .IsBatchProcessing = True

            For curItem As Integer = 0 To .Combo_Variables.Items.Count - 1

                Application.DoEvents()


                .DoNotUpdate = True
                .Combo_Variables.SelectedIndex = curItem
                CurrentVariable = .Combo_Variables.Text
                .DoNotUpdate = False


                ToolStrip_Status.Text = "Processing  " +
                                        (curItem + 1).ToString.Trim +
                                        " of " +
                                        .Combo_Variables.Items.Count.ToString + "  (" +
                                        CurrentVariable + ")"
                StatusStrip.Refresh()


                If .Refresh_Chart(True, False) = "" Then
                    Save_SingleChartData_To_File(CurrentVariable,
                                                 Check_Raw,
                                                 .Chart_RawData,
                                                 TargetFolder,
                                                 IsConfineDate,
                                                 ExportDate1, ExportDate2,
                                                 FileExtension,
                                                 isShowProgressWindow)

                    Save_SingleChartData_To_File(CurrentVariable,
                                                 Check_Raw_MedianFiltered,
                                                 .Chart_Raw_Filtered,
                                                 TargetFolder,
                                                 IsConfineDate,
                                                 ExportDate1, ExportDate2,
                                                 FileExtension,
                                                 isShowProgressWindow)

                    Save_SingleChartData_To_File(CurrentVariable,
                                                 Check_CenterCurve,
                                                 .Chart_CenterCurve,
                                                 TargetFolder,
                                                 IsConfineDate,
                                                 ExportDate1, ExportDate2,
                                                 FileExtension,
                                                 isShowProgressWindow)

                    Save_SingleChartData_To_File(CurrentVariable,
                                                 Check_Deviation,
                                                 .Chart_Deviation,
                                                 TargetFolder,
                                                 IsConfineDate,
                                                 ExportDate1, ExportDate2,
                                                 FileExtension,
                                                 isShowProgressWindow)

                    Save_SingleChartData_To_File(CurrentVariable,
                                                 Check_Deviation_MedianFiltered,
                                                 .Chart_Deviation_Filtered,
                                                 TargetFolder,
                                                 IsConfineDate,
                                                 ExportDate1, ExportDate2,
                                                 FileExtension,
                                                 isShowProgressWindow)

                    Save_SingleChartData_To_File(CurrentVariable,
                                                 Check_AbsDeviation,
                                                 .Chart_AbsDeviation,
                                                 TargetFolder,
                                                 IsConfineDate,
                                                 ExportDate1, ExportDate2,
                                                 FileExtension,
                                                 isShowProgressWindow)

                    Save_SingleChartData_To_File(CurrentVariable,
                                                 Check_AbsDeviation_MedianFiltered,
                                                 .Chart_AbsDeviation_Filtered,
                                                 TargetFolder,
                                                 IsConfineDate,
                                                 ExportDate1, ExportDate2,
                                                 FileExtension,
                                                 isShowProgressWindow)

                    Save_SingleChartData_To_File(CurrentVariable,
                                                 Check_Deviation_PeakValue,
                                                 .Chart_Deviation_PeakValue,
                                                 TargetFolder,
                                                 IsConfineDate,
                                                 ExportDate1, ExportDate2,
                                                 FileExtension,
                                                 isShowProgressWindow)

                    Save_SingleChartData_To_File(CurrentVariable,
                                                 Check_Deviation_PeakTimeHr,
                                                 .Chart_Deviation_PeakTimeHr,
                                                 TargetFolder,
                                                 IsConfineDate,
                                                 ExportDate1, ExportDate2,
                                                 FileExtension,
                                                 isShowProgressWindow)

                    Save_SingleChartData_To_File(CurrentVariable,
                                                 Check_Deviation_TroughValue,
                                                 .Chart_Deviation_TroughValue,
                                                 TargetFolder,
                                                 IsConfineDate,
                                                 ExportDate1, ExportDate2,
                                                 FileExtension,
                                                 isShowProgressWindow)

                    Save_SingleChartData_To_File(CurrentVariable,
                                                 Check_Deviation_TroughTimeHr,
                                                 .Chart_Deviation_TroughTimeHr,
                                                 TargetFolder,
                                                 IsConfineDate,
                                                 ExportDate1, ExportDate2,
                                                 FileExtension,
                                                 isShowProgressWindow)

                    Save_SingleChartData_To_File(CurrentVariable,
                                                 Check_Deviation_PeakToPeakAmplitude,
                                                 .Chart_Deviation_PeakToPeakAmplitude,
                                                 TargetFolder,
                                                 IsConfineDate,
                                                 ExportDate1, ExportDate2,
                                                 FileExtension,
                                                 isShowProgressWindow)
                End If
            Next
            Application.DoEvents()

            .IsBatchProcessing = False

            .Refresh_Chart()
        End With


        ToolStrip_Status.Text = "Exporting data completed!"
        StatusStrip.Refresh()

    End Sub


    Sub Save_SingleChartData_To_File(CurrentVariableStr As String,
                                     ByRef Source_CheckBox As CheckBox,
                                     ByRef Source_ChartData As List(Of Frm_Chart.ChartData),
                                     DestFolder As String,
                                     IsConfineDate As Boolean,
                                     Optional ExportDate1 As Date = #2022/1/1#,
                                     Optional ExportDate2 As Date = #2022/2/1#,
                                     Optional FileExtension As String = "txt",
                                     Optional isShowProgressWindow As Boolean = True)

        If Source_CheckBox.Checked = False Then Exit Sub

        Dim Filename As String = Text_ExportData_Prefix.Text +
                                 CurrentVariableStr +
                                 "_" + Source_CheckBox.Text +
                                 "." + FileExtension

        Dim RetMsg As String =
                Frm_Chart.Save_ChartData(Source_ChartData,
                                         DestFolder + "\" +
                                         Filename,
                                         FileExtension,
                                         IsConfineDate,
                                         ExportDate1,
                                         ExportDate2,
                                         isShowProgressWindow)

        If RetMsg <> "" Then
            Dim myItemDetails(2) As String

            myItemDetails(0) = CurrentVariableStr
            myItemDetails(1) = Source_CheckBox.Text
            myItemDetails(2) = RetMsg

            Dim myItems As New ListViewItem(myItemDetails)

            ListView_ExportDataErrors.Items.Add(myItems)
            ListView_ExportDataErrors.Items(
                ListView_ExportDataErrors.Items.Count - 1).EnsureVisible()
        End If


        Application.DoEvents()
    End Sub

    Private Sub Cmd_SetExportDataNewFolder_Click(sender As Object, e As EventArgs) _
        Handles Cmd_SetExportDataNewFolder.Click
        With ExportDataFolderDialog
            If MyFile.FolderExists(Text_TargetExportDataSaveFolder.Text) Then
                .SelectedPath = Text_TargetExportDataSaveFolder.Text
            End If

            If .ShowDialog = DialogResult.OK Then
                LastExportDataSaveTargetFolder = .SelectedPath
                Text_TargetExportDataSaveFolder.Text = LastExportDataSaveTargetFolder
            End If
        End With
    End Sub


    Private Sub Check_ConfineDate_CheckedChanged(sender As Object, e As EventArgs) _
        Handles Check_ConfineExportDate.CheckedChanged
        Date_ExportDate1.Enabled = Check_ConfineExportDate.Checked
        Date_ExportDate2.Enabled = Check_ConfineExportDate.Checked
    End Sub



    Function Compute_Stats_Core(NumberArray() As Double) As StatsFormat
        Dim OutStat As New StatsFormat
        Dim AllValues(ComputeStats_AllValues_UpperIndex) As Single

        '초기화
        If NumberArray Is Nothing Then
            OutStat.n = "0"
            AllValues(0) = 0
            OutStat.AllValues = AllValues
            Return OutStat
        End If


        Dim Stat_N As Long = NumberArray.Count
        Dim Stat_Sum As Double
        Dim Stat_Mean, Stat_Stdev As Double
        Dim Stat_Min, Stat_Max As Double
        Dim Stat_SumAbsDiff_3rd, Stat_SumAbsDiff_4th As Double
        Dim Stat_PercentileQ1, Stat_PercentileQ2, Stat_PercentileQ3 As Double
        Dim Stat_Skewness, Stat_Kurtosis As Double
        Dim Stat_CV, Stat_RMS As Double


        With OutStat
            .n = Stat_N.ToString.Trim
            .Mean = ""
            .Stdev = ""
            .Min = ""
            .Max = ""
            .PercentQ1 = ""
            .PercentQ2 = ""
            .PercentQ3 = ""
            .Skewness = ""
            .Kurtosis = ""
            .Sum = ""
            .CV = ""
            .RMS = ""

            AllValues(0) = Stat_N

            If Stat_N > 2 Then
                Stat_Sum = NumberArray.Sum
                Stat_Mean = Stat_Sum / CDbl(NumberArray.Count)
                .Mean = Format(Stat_Mean, "0.00000")
                AllValues(1) = Stat_Mean

                Stat_Stdev = MyMath.Compute_Stdev(NumberArray, Stat_Mean)
                .Stdev = Format(Stat_Stdev, "0.00000")
                AllValues(2) = Stat_Stdev

                Dim NumberArraySorted() As Double = MyMath.SortNumberArray(NumberArray)


                Stat_Min = NumberArraySorted(0)
                Stat_Max = NumberArraySorted(Stat_N - 1)
                .Min = Format(Stat_Min, "0.00000")
                .Max = Format(Stat_Max, "0.00000")
                AllValues(3) = Stat_Min
                AllValues(4) = Stat_Max


                Stat_PercentileQ1 = MyMath.Compute_Percentile_From_SortedNumbers(NumberArraySorted,
                                                                                 0.25)
                Stat_PercentileQ2 = MyMath.Compute_Percentile_From_SortedNumbers(NumberArraySorted,
                                                                                 0.5)
                Stat_PercentileQ3 = MyMath.Compute_Percentile_From_SortedNumbers(NumberArraySorted,
                                                                                 0.75)
                .PercentQ1 = Format(Stat_PercentileQ1, "0.00000")
                .PercentQ2 = Format(Stat_PercentileQ2, "0.00000")
                .PercentQ3 = Format(Stat_PercentileQ3, "0.00000")
                AllValues(5) = Stat_PercentileQ1
                AllValues(6) = Stat_PercentileQ2
                AllValues(7) = Stat_PercentileQ3

                If Stat_Stdev > 0 Then
                    Stat_SumAbsDiff_3rd = MyMath.Compute_SumAbsDiff_3rd(NumberArray, Stat_Mean)
                    Stat_SumAbsDiff_4th = MyMath.Compute_SumAbsDiff_4th(NumberArray, Stat_Mean)
                    Stat_Skewness = MyMath.Compute_Skewness(Stat_N, Stat_Stdev, Stat_SumAbsDiff_3rd)
                    Stat_Kurtosis = MyMath.Compute_Kurtosis(Stat_N, Stat_Stdev, Stat_SumAbsDiff_4th)

                    If Double.IsNaN(Stat_Skewness) Then
                        .Skewness = ""
                    Else
                        .Skewness = Format(Stat_Skewness, "0.00000")
                        AllValues(8) = Stat_Skewness
                    End If

                    If Double.IsNaN(Stat_Kurtosis) Then
                        .Kurtosis = ""
                    Else
                        .Kurtosis = Format(Stat_Kurtosis, "0.00000")
                        AllValues(9) = Stat_Kurtosis
                    End If

                Else
                    .Skewness = ""
                    .Kurtosis = ""
                    AllValues(8) = 0
                    AllValues(9) = 0
                End If

                OutStat.Sum = Format(Stat_Sum, "0.00000")
                AllValues(10) = Stat_Sum

                If Stat_Mean <> 0 Then
                    Stat_CV = Stat_Stdev / Stat_Mean

                    If Double.IsNaN(Stat_CV) Then
                        OutStat.CV = ""
                        AllValues(11) = Stat_CV
                    Else
                        OutStat.CV = Format(Stat_CV, "0.00000")
                        AllValues(11) = Stat_CV
                    End If
                Else
                    OutStat.CV = ""
                    AllValues(11) = Stat_CV
                End If

                Stat_RMS = MyMath.Compute_RMS(NumberArray)
                OutStat.RMS = Format(Stat_RMS, "0.00000")
                AllValues(12) = Stat_RMS


            ElseIf Stat_N > 0 Then
                Stat_Sum = NumberArray.Sum
                Stat_Mean = Stat_Sum / CDbl(NumberArray.Count)
                .Mean = Format(Stat_Mean, "0.00000")
                AllValues(1) = Stat_Mean

                .Skewness = ""
                .Kurtosis = ""
                .CV = ""
                .RMS = ""
                AllValues(8) = 0
                AllValues(9) = 0
                AllValues(11) = 0
                AllValues(12) = 0
            Else
            End If


            .AllValues = AllValues
        End With

        Return OutStat
    End Function


    Public Sub Save_GridAsFile(SrcGrid As ReoGridControl, FullFileName As String)
        Dim FileExt As String = MyFileLocal.Get_FileExtension_From_FullFileName(FullFileName).ToLower

        Try
            Select Case FileExt.ToLower
                Case ".xlsx"
                    SrcGrid.Save(FullFileName)
                    MsgBox("Excel file created", MsgBoxStyle.OkOnly, "Save")

                Case ".csv", ".txt", ".zip", ".7z"
                    ToolStrip_Status.Text = "Saving to file"
                    StatusStrip.Refresh()


                    Dim RowUpperIndex As Integer = 0
                    Dim tempArray(,) As String =
                            ReadFromExcelSheet(SrcGrid.Worksheets(0),
                                               ComputeStats_SheetColUpperIndex, RowUpperIndex)
                    Dim OutLongStr As String =
                            MyText.Convert_String2DYXArray_To_LongString(
                                tempArray, If(FileExt.ToLower = ".csv", ",", vbTab),
                                0, 0)

                    Dim RetStr As String = MyArchive.SaveStringToFile(OutLongStr, FullFileName, True)

                    If RetStr <> "" Then
                        MsgBox(RetStr, MsgBoxStyle.Critical, "Error")
                        ToolStrip_Status.Text = "Fail to save"
                        Exit Sub
                    End If


                    MsgBox("File save successful", MsgBoxStyle.OkOnly, "Save")

            End Select

        Catch ee As Exception

            MsgBox(ee.Message, MsgBoxStyle.Critical, "Save error")

        End Try
    End Sub


    Public Sub Save_ComputeStats_OutTableAsFile(ByRef SourceOutTable As List(Of DailyMonthlyStatsFormat),
                                                FullFileName As String)


        Dim FileExt As String =
                MyFileLocal.Get_FileExtension_From_FullFileName(FullFileName).ToLower

        Try
            Dim OutLongStr As String = Convert_List_DailyMonthlyStatsFormatArray_To_LongString(
                ComputeStats_OutTable,
                If(FileExt.ToLower = ".csv", ",", vbTab))
            Dim RetStr As String = MyArchive.SaveStringToFile(OutLongStr, FullFileName, True)
            If RetStr <> "" Then
                MsgBox(RetStr, MsgBoxStyle.Critical, "Error")
                ToolStrip_Status.Text = "Fail to save"
                Exit Sub
            End If


            MsgBox("File save successful", MsgBoxStyle.OkOnly, "Save")

        Catch ee As Exception
            MsgBox(ee.Message, MsgBoxStyle.Critical, "Save error")
        End Try
    End Sub

    Public Function Convert_List_DailyMonthlyStatsFormatArray_To_LongString(
                                                                            ByRef SourceOutTable As _
                                                                               List(Of DailyMonthlyStatsFormat),
                                                                            delimitStr As String) As String
        Dim OutStr As New StringBuilder
        Dim RowUpperIndex As Integer
        Dim q As Integer

        RowUpperIndex = SourceOutTable.Count - 1

        For q = 0 To RowUpperIndex
            OutStr.Append(SourceOutTable(q).Filename + delimitStr)
            OutStr.Append(SourceOutTable(q).Variable + delimitStr)
            OutStr.Append(SourceOutTable(q).Feature + delimitStr)
            OutStr.Append(SourceOutTable(q).Year + delimitStr)
            OutStr.Append(SourceOutTable(q).Month + delimitStr)
            OutStr.Append(SourceOutTable(q).Day + delimitStr)
            OutStr.Append(SourceOutTable(q).n + delimitStr)
            OutStr.Append(SourceOutTable(q).Mean + delimitStr)
            OutStr.Append(SourceOutTable(q).Stdev + delimitStr)
            OutStr.Append(SourceOutTable(q).Min + delimitStr)
            OutStr.Append(SourceOutTable(q).Max + delimitStr)
            OutStr.Append(SourceOutTable(q).PercentQ1 + delimitStr)
            OutStr.Append(SourceOutTable(q).PercentQ2 + delimitStr)
            OutStr.Append(SourceOutTable(q).PercentQ3 + delimitStr)
            OutStr.Append(SourceOutTable(q).Skewness + delimitStr)
            OutStr.Append(SourceOutTable(q).Kurtosis + delimitStr)
            OutStr.Append(SourceOutTable(q).Sum + delimitStr)
            OutStr.Append(SourceOutTable(q).CV + delimitStr)
            OutStr.Append(SourceOutTable(q).RMS + vbCrLf)
        Next

        Return OutStr.ToString
    End Function


    Private Sub Date_ExportDate1_ValueChanged(sender As Object, e As EventArgs) Handles Date_ExportDate1.ValueChanged
        With Date_ExportDate1
            .Value = New Date(.Value.Year, .Value.Month, .Value.Day, .0, 0, 0)
            Date_ExportDate2.MinDate = .Value
        End With
    End Sub

    Private Sub Date_ExportDate2_ValueChanged(sender As Object, e As EventArgs) Handles Date_ExportDate2.ValueChanged
        With Date_ExportDate2
            .Value = New Date(.Value.Year, .Value.Month, .Value.Day, 23, 59, 59)
            Date_ExportDate1.MaxDate = .Value
        End With
    End Sub


    Private Sub Cmd_ExportUncheckAll_Click(sender As Object, e As EventArgs) Handles Cmd_ExportUncheckAll.Click
        Check_Raw.Checked = False
        Check_Raw_MedianFiltered.Checked = False
        Check_CenterCurve.Checked = False
        Check_Deviation.Checked = False
        Check_Deviation_MedianFiltered.Checked = False
        Check_Deviation_PeakValue.Checked = False
        Check_Deviation_TroughValue.Checked = False
        Check_Deviation_PeakTimeHr.Checked = False
        Check_Deviation_TroughTimeHr.Checked = False
        Check_Deviation_PeakToPeakAmplitude.Checked = False
        Check_AbsDeviation.Checked = False
        Check_AbsDeviation_MedianFiltered.Checked = False
    End Sub

    Private Sub Cmd_ExportCheckAll_Click(sender As Object, e As EventArgs) Handles Cmd_ExportCheckAll.Click
        Check_Raw.Checked = True
        Check_Raw_MedianFiltered.Checked = True
        Check_CenterCurve.Checked = True
        Check_Deviation.Checked = True
        Check_Deviation_MedianFiltered.Checked = True
        Check_Deviation_PeakValue.Checked = True
        Check_Deviation_TroughValue.Checked = True
        Check_Deviation_PeakTimeHr.Checked = True
        Check_Deviation_TroughTimeHr.Checked = True
        Check_Deviation_PeakToPeakAmplitude.Checked = True
        Check_AbsDeviation.Checked = True
        Check_AbsDeviation_MedianFiltered.Checked = True
    End Sub



    Private Sub Cmd_ComputeNowDailyStats_Click(sender As Object, e As EventArgs) Handles Cmd_ComputeNowDailyStats.Click
        ComputeStats()
    End Sub

    Sub ComputeStats()
        Cmd_ComputeNowDailyStats.Enabled = False
        If Radio_ComputeStat_Daily.Checked Then
            Compute_DailyStats(Check_TimeWindowAveraging.Checked,
                               Val(Combo_TimeWindowAveragingDay.Text),
                               Check_ComputeStat_AnalyzeEveryday.Checked)
        ElseIf Radio_ComputeStat_Monthly.Checked Then
            Compute_MonthlyStats()
        End If
        Cmd_ComputeNowDailyStats.Enabled = True
    End Sub


    Private Sub Cmd_CopyAllDaily_Click(sender As Object, e As EventArgs) Handles Cmd_CopyAllDaily.Click
        With Grid_DailyStats
            .Worksheets(0).SelectionRange =
                New RangePosition(0, 0,
                                  .Worksheets(0).RowCount,
                                  .Worksheets(0).ColumnCount)

            .Worksheets(0).Copy()
        End With
    End Sub


    Public Function Compute_DailyStats_InTable(ByRef BeginDate As Date,
                                               ByRef EndDate As Date) As List(Of DailyMonthlyStatsFormat)
        Dim y, q As Integer


        Dim FullPathFiles() As String =
                FileDDBox_DailyStats.Get_FullPathFileNames()
        Dim FullPathFiles_UpperBound As Integer =
                FullPathFiles.GetUpperBound(0)


        ToolStrip_Status.Text = "Source text files: total " +
                                FullPathFiles.Count.ToString.Trim + " files"
        StatusStrip.Refresh()


        Dim OutTable As New List(Of DailyMonthlyStatsFormat)  '모든 결과를 저정하는 변수

        Dim OutDailyMonthlyStat As New DailyMonthlyStatsFormat
        Dim AllValues(ComputeStats_AllValues_UpperIndex) As Single

        With OutDailyMonthlyStat
            .Filename = "File name"
            .Variable = "Variable"
            .Feature = "Feature"
            .Year = "Year"
            .Month = "Month"
            .Day = "Day"
            .n = "n"
            .Mean = "Mean"
            .Stdev = "Stdev"
            .Min = "Min"
            .Max = "Max"
            .PercentQ1 = "Percent.Q1"
            .PercentQ2 = "Percent.Q2"
            .PercentQ3 = "Percent.Q3"
            .Skewness = "Skewness"
            .Kurtosis = "Kurtosis"
            .Sum = "Sum"
            .CV = "CV"
            .RMS = "RMS"
            .AllValues = AllValues
        End With
        OutTable.Add(OutDailyMonthlyStat)


        For y = 0 To FullPathFiles_UpperBound

            Dim curDataTable As String()() = MyText.Get_String2DAarry_From_File_Parallel(FullPathFiles(y), False)

            If curDataTable(0).GetUpperBound(0) <> 1 Then
                Application.DoEvents()
                ToolStrip_Status.Text = "Processing  " +
                                        Format(y + 1, "###,###") +
                                        " of " +
                                        Format(FullPathFiles_UpperBound, "###,###") +
                                        "  : " +
                                        MyFileLocal.Get_OnlyFileName_From_FullFileName(FullPathFiles(y))
                StatusStrip.Refresh()

                Continue For
            End If


            Dim ArrayRows As Integer = curDataTable.GetUpperBound(0)


            Dim DateBegin As Date = CDate(Strings.Left(curDataTable(0)(0), 10))

            Dim TotalDays As Integer = DateDiff(DateInterval.Day,
                                                DateBegin,
                                                CDate(Strings.Left(curDataTable(ArrayRows)(0), 10))) + 1

            Dim RawData(TotalDays) As List(Of Double)
            Dim DateStr(TotalDays) As String

            Dim Dict_DateIndex As New Dictionary(Of String, Integer)


            Dim CurDate As Date
            Dim CurDateStr As String
            For q = 1 To TotalDays
                CurDate = DateBegin.AddDays(q - 1)
                CurDateStr = MyTime.Get_TimeFormat_yyyy_mm_dd(CurDate)
                Dict_DateIndex.Add(CurDateStr, q)
                DateStr(q) = CurDateStr
            Next


            Dim DateIndex As Integer


            'Date별로 데이터 수집
            For q = 0 To ArrayRows
                If Date.TryParse(curDataTable(q)(0), CurDate) = False Then
                    Continue For
                End If

                CurDateStr = Strings.Left(curDataTable(q)(0), 10)


                If curDataTable(q).GetUpperBound(0) = 1 Then
                    DateIndex = Dict_DateIndex(CurDateStr)
                    If RawData(DateIndex) Is Nothing Then
                        RawData(DateIndex) = New List(Of Double)
                    End If
                    RawData(DateIndex).Add(curDataTable(q)(1).Trim)
                Else
                    MsgBox("Computing has been aborted" + vbCrLf + vbCrLf +
                           "Wrong file: " + FullPathFiles(y),
                           MsgBoxStyle.Critical, "Error")

                    ToolStrip_Status.Text = "Computing has been aborted"
                    Return Nothing
                End If


                If q Mod 1000 = 0 Then
                    Application.DoEvents()
                End If
            Next




            'Date별로 수집된 데이터 분석
            For q = 1 To TotalDays

                Dim NumberArray() As Double

                If RawData(q) Is Nothing Then
                    NumberArray = Nothing
                Else
                    NumberArray = RawData(q).ToArray()
                End If


                OutDailyMonthlyStat.Filename =
                    MyFileLocal.Get_OnlyFileName_From_FullFileName(FullPathFiles(y))

                Dim Pos_under As Integer = InStr(OutDailyMonthlyStat.Filename, "_")
                Dim Pos_dot As Integer =
                        MyFileLocal.Get_FilenameWithoutExtension_From_ShortFileName(
                            OutDailyMonthlyStat.Filename).Length + 1

                If Pos_under = -1 OrElse Pos_dot = -1 Then
                    OutDailyMonthlyStat.Variable = "NA"
                    OutDailyMonthlyStat.Feature = "NA"
                Else
                    If Pos_under = 0 Then
                        MsgBox("Computing has been aborted" + vbCrLf + vbCrLf +
                               "Wrong file: " + FullPathFiles(y),
                               MsgBoxStyle.Critical, "Error")

                        ToolStrip_Status.Text = "Computing has been aborted"
                        Return Nothing
                    End If

                    OutDailyMonthlyStat.Variable =
                        Strings.Left(OutDailyMonthlyStat.Filename, Pos_under - 1)
                    OutDailyMonthlyStat.Feature =
                        Mid(OutDailyMonthlyStat.Filename,
                            Pos_under + 1, Pos_dot - Pos_under - 1)
                End If


                Dim OutStat As StatsFormat = Compute_Stats_Core(NumberArray)

                With OutDailyMonthlyStat
                    .Year = CInt(Strings.Left(DateStr(q), 4))
                    .Month = CSng(Mid(DateStr(q), 6, 2))
                    .Day = Strings.Right(DateStr(q), 2)
                    .n = OutStat.n
                    .Mean = OutStat.Mean
                    .Stdev = OutStat.Stdev
                    .Min = OutStat.Min
                    .Max = OutStat.Max
                    .PercentQ1 = OutStat.PercentQ1
                    .PercentQ2 = OutStat.PercentQ2
                    .PercentQ3 = OutStat.PercentQ3
                    .Skewness = OutStat.Skewness
                    .Kurtosis = OutStat.Kurtosis
                    .Sum = OutStat.Sum
                    .CV = OutStat.CV
                    .RMS = OutStat.RMS
                    .AllValues = OutStat.AllValues

                    CurDate = New Date(CInt(.Year), CInt(.Month), CInt(.Day))
                End With


                If BeginDate > CurDate Then
                    BeginDate = CurDate
                End If
                If EndDate < CurDate Then
                    EndDate = CurDate
                End If


                OutTable.Add(OutDailyMonthlyStat)


                If q Mod 100 = 0 Then
                    Application.DoEvents()

                    ToolStrip_Status.Text = "Processing  " +
                                            Format(y + 1, "###,###") +
                                            " of " +
                                            Format(FullPathFiles_UpperBound, "###,###") +
                                            "  : " +
                                            MyFileLocal.Get_OnlyFileName_From_FullFileName(FullPathFiles(y))
                    StatusStrip.Refresh()
                End If

            Next


            '파일 처리가 끝나면 한줄 blank 라인 추가
            With OutDailyMonthlyStat
                .Filename = ""
                .Variable = ""
                .Feature = ""
                .Year = ""
                .Month = ""
                .Day = ""
                .n = ""
                .Mean = ""
                .Stdev = ""
                .Min = ""
                .Max = ""
                .PercentQ1 = ""
                .PercentQ2 = ""
                .PercentQ3 = ""
                .Skewness = ""
                .Kurtosis = ""
                .Sum = ""
                .CV = ""
                .RMS = ""
                .AllValues = New Single(ComputeStats_AllValues_UpperIndex) {}
            End With
            OutTable.Add(OutDailyMonthlyStat)

        Next


        ToolStrip_Status.Text = "Processing completed!"
        StatusStrip.Refresh()


        Return OutTable
    End Function


    Public Function Compute_DailyStatsAveraged_InTable(
                                                       DailyStats_InTable As List(Of DailyMonthlyStatsFormat),
                                                       TimeWindowAveragingDays As Integer,
                                                       IsAnalyzeEveryDay As Boolean,
                                                       BeginDate As Date,
                                                       EndDate As Date) As List(Of DailyMonthlyStatsFormat)


        Dim Out_DailyStats_InTable As New List(Of DailyMonthlyStatsFormat)
        Dim Out_DailyMonthlyStat As New DailyMonthlyStatsFormat
        Dim TimeWindowAveragingDaysHalf As Integer =
                CInt((TimeWindowAveragingDays - 1) / 2)


        Dim LineIndexMax As Integer = DailyStats_InTable.Count - 1

        Out_DailyStats_InTable.Add(DailyStats_InTable(0))


        Dim Dict_SelectedDate As New Dictionary(Of String, Integer)
        Dim curDateStr As String

        If IsAnalyzeEveryDay = False Then
            Dim TotalDays As Integer = DateDiff(DateInterval.Day, BeginDate, EndDate)

            For y As Integer = 0 To TotalDays - 1 Step TimeWindowAveragingDays
                Dim curDate As Date = BeginDate.AddDays(y)
                curDateStr = MyTime.Get_TimeFormat_yyyy_mm_dd(curDate)

                Dict_SelectedDate.Add(curDateStr, y)
            Next

        End If


        Dim RangeBegin, RangeEnd As Integer
        Dim ComputeBegin, ComputeEnd As Integer
        Dim isNeedFindRangeEnd As Boolean

        With Out_DailyMonthlyStat
            For curIndex As Integer = 1 To LineIndexMax
                .Filename = DailyStats_InTable(curIndex).Filename
                .Variable = DailyStats_InTable(curIndex).Variable
                .Feature = DailyStats_InTable(curIndex).Feature
                .Year = DailyStats_InTable(curIndex).Year
                .Month = DailyStats_InTable(curIndex).Month
                .Day = DailyStats_InTable(curIndex).Day
                .AllValues = New Single(ComputeStats_AllValues_UpperIndex) {}

                If IsAnalyzeEveryDay = False Then
                    If .Year = "" OrElse .Month = "" OrElse .Day = "" Then
                        Continue For
                    Else
                        curDateStr = MyTime.Get_TimeFormat_yyyy_mm_dd(
                            New Date(CInt(.Year), CInt(.Month), CInt(.Day)))
                        If Dict_SelectedDate.ContainsKey(curDateStr) = False Then
                            Continue For
                        End If
                    End If
                End If


                If curIndex = 1 Then
                    RangeBegin = 1
                    isNeedFindRangeEnd = True
                ElseIf DailyStats_InTable(curIndex).Filename = "" Then
                    Out_DailyStats_InTable.Add(DailyStats_InTable(curIndex))
                    Continue For
                ElseIf DailyStats_InTable(curIndex - 1).Filename = "" AndAlso
                       DailyStats_InTable(curIndex).Filename <> "" Then
                    RangeBegin = curIndex
                    isNeedFindRangeEnd = True
                Else
                    isNeedFindRangeEnd = True
                End If

                If isNeedFindRangeEnd Then
                    RangeEnd = -1
                    For w As Integer = curIndex + 1 To LineIndexMax
                        If DailyStats_InTable(w).Filename = "" Then
                            RangeEnd = w - 1
                            Exit For
                        End If
                    Next
                    If RangeEnd = -1 Then
                        RangeEnd = LineIndexMax
                    End If
                End If


                If curIndex - TimeWindowAveragingDaysHalf > RangeBegin Then
                    ComputeBegin = curIndex - TimeWindowAveragingDaysHalf
                Else
                    ComputeBegin = RangeBegin
                End If
                If curIndex + TimeWindowAveragingDaysHalf < RangeEnd Then
                    ComputeEnd = curIndex + TimeWindowAveragingDaysHalf
                Else
                    ComputeEnd = RangeEnd
                End If


                '평균값을 구함
                Dim SumValues(ComputeStats_AllValues_UpperIndex) As Single
                Dim CountValues(ComputeStats_AllValues_UpperIndex) As Integer
                Dim AvgValues(ComputeStats_AllValues_UpperIndex) As Single
                Dim MeanRawValueList As New List(Of Double)

                For q As Integer = ComputeBegin To ComputeEnd
                    If DailyStats_InTable(q).n <> "" AndAlso DailyStats_InTable(q).n <> "0" Then
                        CountValues(0) += 1
                        SumValues(0) +=
                            DailyStats_InTable(q).AllValues(0)
                    End If
                    If DailyStats_InTable(q).Mean <> "" Then
                        CountValues(1) += 1
                        SumValues(1) +=
                            DailyStats_InTable(q).AllValues(1)
                        MeanRawValueList.Add(DailyStats_InTable(q).AllValues(1))
                    End If
                    If DailyStats_InTable(q).Stdev <> "" Then
                        CountValues(2) += 1
                        SumValues(2) +=
                            DailyStats_InTable(q).AllValues(2)
                    End If
                    If DailyStats_InTable(q).Min <> "" Then
                        CountValues(3) += 1
                        SumValues(3) +=
                            DailyStats_InTable(q).AllValues(3)
                    End If
                    If DailyStats_InTable(q).Max <> "" Then
                        CountValues(4) += 1
                        SumValues(4) +=
                            DailyStats_InTable(q).AllValues(4)
                    End If
                    If DailyStats_InTable(q).PercentQ1 <> "" Then
                        CountValues(5) += 1
                        SumValues(5) +=
                            DailyStats_InTable(q).AllValues(5)
                    End If
                    If DailyStats_InTable(q).PercentQ2 <> "" Then
                        CountValues(6) += 1
                        SumValues(6) +=
                            DailyStats_InTable(q).AllValues(6)
                    End If
                    If DailyStats_InTable(q).PercentQ3 <> "" Then
                        CountValues(7) += 1
                        SumValues(7) +=
                            DailyStats_InTable(q).AllValues(7)
                    End If
                    If DailyStats_InTable(q).Skewness <> "" Then
                        CountValues(8) += 1
                        SumValues(8) +=
                            DailyStats_InTable(q).AllValues(8)
                    End If
                    If DailyStats_InTable(q).Kurtosis <> "" Then
                        CountValues(9) += 1
                        SumValues(9) +=
                            DailyStats_InTable(q).AllValues(9)
                    End If
                    If DailyStats_InTable(q).Sum <> "" Then
                        CountValues(10) += 1
                        SumValues(10) +=
                            DailyStats_InTable(q).AllValues(10)
                    End If
                    If DailyStats_InTable(q).CV <> "" Then
                        CountValues(11) += 1
                        SumValues(11) +=
                            DailyStats_InTable(q).AllValues(11)
                    End If
                    If DailyStats_InTable(q).RMS <> "" Then
                        CountValues(12) += 1
                        SumValues(12) +=
                            DailyStats_InTable(q).AllValues(12)
                    End If
                Next


                For q As Integer = 0 To 12
                    If CountValues(q) > 0 Then
                        AvgValues(q) = SumValues(q) / CountValues(q)
                    End If
                Next


                '만약 n=1로 평균값만 있고 다른 통계치는 없을 때,
                If AvgValues(0) = 1 Then
                    Dim MeanRawValues As Double() = MeanRawValueList.ToArray
                    Dim OutStat As StatsFormat = Compute_Stats_Core(MeanRawValues)

                    .AllValues(0) = OutStat.n
                    .n = .AllValues(0)
                    .AllValues = OutStat.AllValues

                    .Mean = OutStat.Mean
                    .Stdev = OutStat.Stdev
                    .Min = OutStat.Min
                    .Max = OutStat.Max
                    .PercentQ1 = OutStat.PercentQ1
                    .PercentQ2 = OutStat.PercentQ2
                    .PercentQ3 = OutStat.PercentQ3
                    .Skewness = OutStat.Skewness
                    .Kurtosis = OutStat.Kurtosis
                    .Sum = OutStat.Sum
                    .CV = OutStat.CV
                    .RMS = OutStat.RMS
                Else
                    .AllValues(0) = DailyStats_InTable(curIndex).AllValues(0)
                    .n = .AllValues(0)

                    If CountValues(1) > 0 Then
                        .Mean = Format(AvgValues(1), "0.00000")
                        .AllValues(1) = AvgValues(1)
                    Else
                        .Mean = ""
                    End If
                    If CountValues(2) > 0 Then
                        .Stdev = Format(AvgValues(2), "0.00000")
                        .AllValues(2) = AvgValues(2)
                    Else
                        .Stdev = ""
                    End If
                    If CountValues(3) > 0 Then
                        .Min = Format(AvgValues(3), "0.000")
                        .AllValues(3) = AvgValues(3)
                    Else
                        .Min = ""
                    End If
                    If CountValues(4) > 0 Then
                        .Max = Format(AvgValues(4), "0.000")
                        .AllValues(4) = AvgValues(4)
                    Else
                        .Max = ""
                    End If
                    If CountValues(5) > 0 Then
                        .PercentQ1 = Format(AvgValues(5), "0.00000")
                        .AllValues(5) = AvgValues(5)
                    Else
                        .PercentQ1 = ""
                    End If
                    If CountValues(6) > 0 Then
                        .PercentQ2 = Format(AvgValues(6), "0.00000")
                        .AllValues(6) = AvgValues(6)
                    Else
                        .PercentQ2 = ""
                    End If
                    If CountValues(7) > 0 Then
                        .PercentQ3 = Format(AvgValues(7), "0.00000")
                        .AllValues(7) = AvgValues(7)
                    Else
                        .PercentQ3 = ""
                    End If
                    If CountValues(8) > 0 Then
                        .Skewness = Format(AvgValues(8), "0.00000")
                        .AllValues(8) = AvgValues(8)
                    Else
                        .Skewness = ""
                    End If
                    If CountValues(9) > 0 Then
                        .Kurtosis = Format(AvgValues(9), "0.00000")
                        .AllValues(9) = AvgValues(9)
                    Else
                        .Kurtosis = ""
                    End If
                    If CountValues(10) > 0 Then
                        .Sum = Format(AvgValues(10), "0.000")
                        .AllValues(10) = AvgValues(10)
                    Else
                        .Sum = ""
                    End If
                    If CountValues(11) > 0 Then
                        .CV = Format(AvgValues(11), "0.00000")
                        .AllValues(11) = AvgValues(11)
                    Else
                        .CV = ""
                    End If
                    If CountValues(12) > 0 Then
                        .RMS = Format(AvgValues(12), "0.0000")
                        .AllValues(12) = AvgValues(12)
                    Else
                        .RMS = ""
                    End If
                End If


                Out_DailyStats_InTable.Add(Out_DailyMonthlyStat)


                If curIndex Mod 1000 = 0 Then
                    Application.DoEvents()

                    ToolStrip_Status.Text = "Post-Processing  " +
                                            Format(curIndex, "###,###") +
                                            " of " +
                                            Format(LineIndexMax, "###,###") +
                                            " lines"
                    StatusStrip.Refresh()
                End If

            Next
        End With

        ToolStrip_Status.Text = "Processing completed!"
        StatusStrip.Refresh()


        Return Out_DailyStats_InTable
    End Function


    Public Sub Compute_DailyStats(isUseTimeWindowAveraging As Boolean,
                                  TimeWindowAveragingDays As Integer,
                                  IsAnalyzeEveryDay As Boolean)
        Dim x, q As Integer
        Dim IsMorethanLineMax As Boolean = False
        Dim LineIndexMax As Integer


        Dim CurWorksheet As Worksheet = Grid_DailyStats.Worksheets(0)

        CurWorksheet.ColumnCount = ComputeStats_SheetColUpperIndex + 1

        CurWorksheet(0, 0) = "File name"
        CurWorksheet(0, 1) = "Variable"
        CurWorksheet(0, 2) = "Feature"
        CurWorksheet(0, 3) = "Year"
        CurWorksheet(0, 4) = "Month"
        CurWorksheet(0, 5) = "Day"
        CurWorksheet(0, 6) = "n"
        CurWorksheet(0, 7) = "Mean"
        CurWorksheet(0, 8) = "Stdev"
        CurWorksheet(0, 9) = "Min"
        CurWorksheet(0, 10) = "Max"
        CurWorksheet(0, 11) = "Percent.Q1"
        CurWorksheet(0, 12) = "Percent.Q2"
        CurWorksheet(0, 13) = "Percent.Q3"
        CurWorksheet(0, 14) = "Skewness"
        CurWorksheet(0, 15) = "Kurtosis"
        CurWorksheet(0, 16) = "Sum"
        CurWorksheet(0, 17) = "CV"
        CurWorksheet(0, 18) = "RMS"
        'CurWorksheet(0, 19) = "Entropy"


        With CurWorksheet
            .RowCount = 1
            .RowHeaderWidth = 70
            .ColumnHeaders(0).Width = 250
            .ColumnHeaders(0).Style.HorizontalAlign =
                ReoGridHorAlign.Left

            For x = 1 To ComputeStats_SheetColUpperIndex
                .ColumnHeaders(x).Style.HorizontalAlign =
                    ReoGridHorAlign.Left
            Next
            .ColumnHeaders(1).Width = 70        'variable
            .ColumnHeaders(2).Width = 190       'feature
            .ColumnHeaders(3).Width = 50        'year
            .ColumnHeaders(4).Width = 40        'month
            .ColumnHeaders(5).Width = 40        'day
            .ColumnHeaders(6).Width = 50        'n    
            .ColumnHeaders(7).Width = 70        'mean
            .ColumnHeaders(8).Width = 70        'stdev
            .ColumnHeaders(9).Width = 70        'min
            .ColumnHeaders(10).Width = 70       'max
            .ColumnHeaders(11).Width = 90       'percentile Q1
            .ColumnHeaders(12).Width = 90       'percentile Q2    
            .ColumnHeaders(13).Width = 90       'percentile Q3
            .ColumnHeaders(14).Width = 80       'skewness    
            .ColumnHeaders(15).Width = 80       'kurtosis
            .ColumnHeaders(16).Width = 80       'sum
            .ColumnHeaders(17).Width = 80       'CV
            .ColumnHeaders(18).Width = 80       'RMS
            '.ColumnHeaders(19).Width = 80       'Entropy


            For x = 0 To ComputeStats_SheetColUpperIndex
                .ColumnHeaders(x).Text = CurWorksheet(0, x)
                .Cells(0, x).Style.Bold = True
                .Cells(0, x).Style.FontSize = 8
            Next


            ComputeStats_OutTable.Clear()

            If isUseTimeWindowAveraging Then
                Dim BeginDate As Date = Now
                Dim EndDate As New Date(1900, 1, 1)
                Dim OutTableRaw As List(Of DailyMonthlyStatsFormat) =
                        Compute_DailyStats_InTable(BeginDate, EndDate)
                ComputeStats_OutTable = Compute_DailyStatsAveraged_InTable(OutTableRaw,
                                                                           TimeWindowAveragingDays,
                                                                           IsAnalyzeEveryDay,
                                                                           BeginDate,
                                                                           EndDate)
            Else
                Dim BeginDate, EndDate As Date
                ComputeStats_OutTable = Compute_DailyStats_InTable(BeginDate, EndDate)
            End If

            If ComputeStats_OutTable Is Nothing Then Exit Sub


            LineIndexMax = ComputeStats_OutTable.Count - 2

            If LineIndexMax > ComputeStats_OutTable_MaxLines Then
                IsMorethanLineMax = True
                LineIndexMax = ComputeStats_OutTable_MaxLines
            End If

            .SuspendUIUpdates()
            For q = 0 To LineIndexMax
                .RowCount += 1

                CurWorksheet(q, 0) = ComputeStats_OutTable(q).Filename
                CurWorksheet(q, 1) = ComputeStats_OutTable(q).Variable
                CurWorksheet(q, 2) = ComputeStats_OutTable(q).Feature
                CurWorksheet(q, 3) = ComputeStats_OutTable(q).Year
                CurWorksheet(q, 4) = ComputeStats_OutTable(q).Month
                CurWorksheet(q, 5) = ComputeStats_OutTable(q).Day
                CurWorksheet(q, 6) = ComputeStats_OutTable(q).n
                CurWorksheet(q, 7) = ComputeStats_OutTable(q).Mean
                CurWorksheet(q, 8) = ComputeStats_OutTable(q).Stdev
                CurWorksheet(q, 9) = ComputeStats_OutTable(q).Min
                CurWorksheet(q, 10) = ComputeStats_OutTable(q).Max
                CurWorksheet(q, 11) = ComputeStats_OutTable(q).PercentQ1
                CurWorksheet(q, 12) = ComputeStats_OutTable(q).PercentQ2
                CurWorksheet(q, 13) = ComputeStats_OutTable(q).PercentQ3
                CurWorksheet(q, 14) = ComputeStats_OutTable(q).Skewness
                CurWorksheet(q, 15) = ComputeStats_OutTable(q).Kurtosis
                CurWorksheet(q, 16) = ComputeStats_OutTable(q).Sum
                CurWorksheet(q, 17) = ComputeStats_OutTable(q).CV
                CurWorksheet(q, 18) = ComputeStats_OutTable(q).RMS


                For x = 0 To ComputeStats_SheetColUpperIndex
                    .Cells(q, x).Style.Bold = True
                    .Cells(q, x).Style.FontSize = 8
                Next


                If q Mod 1000 = 0 Then
                    Application.DoEvents()

                    ToolStrip_Status.Text = "Writing at " +
                                            Format(q, "###,###") +
                                            " of " +
                                            Format(LineIndexMax, "###,###") +
                                            " lines"
                    StatusStrip.Refresh()
                End If

            Next

            .ResumeUIUpdates()
        End With


        'Redraw reogid
        Me.Width += 1
        Me.Width -= 1


        ToolStrip_Status.Text = "Computing stats completed!"
        StatusStrip.Refresh()

        If CurWorksheet.RowCount = 1 Then
            MsgBox("No data generated." + vbCrLf + "Make sure source files are valid.",
                   MsgBoxStyle.Critical, "Warning")
        Else
            If IsMorethanLineMax Then
                MsgBox("Computing stats completed!" + vbCrLf +
                       "The total number of rows is " + Format(ComputeStats_OutTable.Count - 2, "###,###") + "." +
                       vbCrLf +
                       "The table only shows " + Format(ComputeStats_OutTable_MaxLines, "###,###") +
                       " rows, but saving this to a text file saves all the data.",
                       MsgBoxStyle.Information, "Warning")
            Else
                MsgBox("Computing stats completed!",
                       MsgBoxStyle.OkOnly, "Compute stats")
            End If

        End If
    End Sub


    Public Sub Compute_MonthlyStats()
        Dim x, y, q As Integer


        Dim FullPathFiles() As String =
                FileDDBox_DailyStats.Get_FullPathFileNames()
        Dim FullPathFiles_UpperBound As Integer =
                FullPathFiles.GetUpperBound(0)


        ToolStrip_Status.Text = "Source text files: total " +
                                FullPathFiles.Count.ToString.Trim + " files"
        StatusStrip.Refresh()


        Dim CurWorksheet As Worksheet = Grid_DailyStats.Worksheets(0)

        CurWorksheet.ColumnCount = ComputeStats_SheetColUpperIndex + 1

        CurWorksheet(0, 0) = "File name"
        CurWorksheet(0, 1) = "Variable"
        CurWorksheet(0, 2) = "Feature"
        CurWorksheet(0, 3) = "Year"
        CurWorksheet(0, 4) = "Month"
        CurWorksheet(0, 5) = ""
        CurWorksheet(0, 6) = "n"
        CurWorksheet(0, 7) = "Mean"
        CurWorksheet(0, 8) = "Stdev"
        CurWorksheet(0, 9) = "Min"
        CurWorksheet(0, 10) = "Max"
        CurWorksheet(0, 11) = "Percent.Q1"
        CurWorksheet(0, 12) = "Percent.Q2"
        CurWorksheet(0, 13) = "Percent.Q3"
        CurWorksheet(0, 14) = "Skewness"
        CurWorksheet(0, 15) = "Kurtosis"
        CurWorksheet(0, 16) = "Sum"
        CurWorksheet(0, 17) = "CV"
        CurWorksheet(0, 18) = "RMS"


        With CurWorksheet
            .RowCount = 1
            .RowHeaderWidth = 50
            .ColumnHeaders(0).Width = 250
            .ColumnHeaders(0).Style.HorizontalAlign =
                ReoGridHorAlign.Left

            For x = 1 To ComputeStats_SheetColUpperIndex
                .ColumnHeaders(x).Style.HorizontalAlign =
                    ReoGridHorAlign.Left
            Next
            .ColumnHeaders(1).Width = 70        'variable
            .ColumnHeaders(2).Width = 190       'feature
            .ColumnHeaders(3).Width = 50        'year
            .ColumnHeaders(4).Width = 40        'month
            .ColumnHeaders(5).Width = 40        '
            .ColumnHeaders(6).Width = 50        'n    
            .ColumnHeaders(7).Width = 70        'mean
            .ColumnHeaders(8).Width = 70        'stdev
            .ColumnHeaders(9).Width = 70        'min
            .ColumnHeaders(10).Width = 70       'max
            .ColumnHeaders(11).Width = 90       'percentile Q1
            .ColumnHeaders(12).Width = 90       'percentile Q2    
            .ColumnHeaders(13).Width = 90       'percentile Q3
            .ColumnHeaders(14).Width = 80       'skewness    
            .ColumnHeaders(15).Width = 80       'kurtosis
            .ColumnHeaders(16).Width = 80       'sum
            .ColumnHeaders(17).Width = 80       'cv
            .ColumnHeaders(18).Width = 80       'rms


            For x = 0 To ComputeStats_SheetColUpperIndex
                .ColumnHeaders(x).Text = CurWorksheet(0, x)
                .Cells(0, x).Style.Bold = True
                .Cells(0, x).Style.FontSize = 8
            Next


            .SuspendUIUpdates()
            For y = 0 To FullPathFiles_UpperBound

                Dim curDataTable As String()() =
                        MyText.Get_String2DAarry_From_File_Parallel(FullPathFiles(y), False)
                If curDataTable(0).GetUpperBound(0) <> 1 Then
                    Continue For
                End If


                Dim ArrayRows As Integer = curDataTable.GetUpperBound(0)


                Dim DateBegin As Date = CDate(Strings.Left(curDataTable(0)(0), 10))

                Dim TotalMonths As Integer =
                        DateDiff(DateInterval.Month,
                                 DateBegin,
                                 CDate(Strings.Left(curDataTable(ArrayRows)(0), 10))) + 1

                Dim RawData(TotalMonths) As List(Of Double)
                Dim DateStr(TotalMonths) As String

                Dim Dict_DateIndex As New Dictionary(Of String, Integer)


                Dim CurDate As Date
                Dim CurDateStr As String
                For q = 1 To TotalMonths
                    CurDate = DateBegin.AddMonths(q - 1)
                    CurDateStr = MyTime.Get_TimeFormat_yyyy_mm(CurDate)
                    Dict_DateIndex.Add(CurDateStr, q)
                    DateStr(q) = CurDateStr
                Next


                Dim DateIndex As Integer


                'Date별로 데이터 수집
                For q = 0 To ArrayRows
                    If Date.TryParse(curDataTable(q)(0), CurDate) = False Then
                        Continue For
                    End If

                    CurDateStr = Strings.Left(curDataTable(q)(0), 7)


                    If curDataTable(q).GetUpperBound(0) = 1 Then
                        DateIndex = Dict_DateIndex(CurDateStr)
                        If RawData(DateIndex) Is Nothing Then
                            RawData(DateIndex) = New List(Of Double)
                        End If
                        RawData(DateIndex).Add(curDataTable(q)(1).Trim)
                    Else
                        MsgBox("Computing has been aborted" + vbCrLf + vbCrLf +
                               "Wrong file: " + FullPathFiles(y),
                               MsgBoxStyle.Critical, "Error")

                        ToolStrip_Status.Text = "Computing has been aborted"
                        Exit Sub
                    End If


                    If q Mod 1000 = 0 Then
                        Application.DoEvents()
                    End If
                Next



                'Date별로 수집된 데이터 분석
                Dim Filename As String

                For q = 1 To TotalMonths

                    Dim NumberArray() As Double

                    If RawData(q) Is Nothing Then
                        NumberArray = Nothing
                    Else
                        NumberArray = RawData(q).ToArray()
                    End If

                    .RowCount += 1
                    Filename = MyFileLocal.Get_OnlyFileName_From_FullFileName(FullPathFiles(y))
                    CurWorksheet(.RowCount - 1, 0) = Filename
                    Dim Pos_under As Integer = InStr(Filename, "_")
                    Dim Pos_dot As Integer =
                            MyFileLocal.Get_FilenameWithoutExtension_From_ShortFileName(
                                Filename).Length + 1

                    If Pos_under = -1 OrElse Pos_dot = -1 Then
                        CurWorksheet(.RowCount - 1, 1) = "NA"
                        CurWorksheet(.RowCount - 1, 2) = "NA"
                    Else
                        CurWorksheet(.RowCount - 1, 1) = Strings.Left(Filename, Pos_under - 1)
                        CurWorksheet(.RowCount - 1, 2) = Mid(Filename, Pos_under + 1, Pos_dot - Pos_under - 1)
                    End If


                    Dim OutStat As StatsFormat = Compute_Stats_Core(NumberArray)


                    CurWorksheet(.RowCount - 1, 3) = Strings.Left(DateStr(q), 4)
                    CurWorksheet(.RowCount - 1, 4) = Mid(DateStr(q), 6, 2)
                    CurWorksheet(.RowCount - 1, 5) = ""
                    CurWorksheet(.RowCount - 1, 6) = OutStat.n
                    CurWorksheet(.RowCount - 1, 7) = OutStat.Mean
                    CurWorksheet(.RowCount - 1, 8) = OutStat.Stdev
                    CurWorksheet(.RowCount - 1, 9) = OutStat.Min
                    CurWorksheet(.RowCount - 1, 10) = OutStat.Max
                    CurWorksheet(.RowCount - 1, 11) = OutStat.PercentQ1
                    CurWorksheet(.RowCount - 1, 12) = OutStat.PercentQ2
                    CurWorksheet(.RowCount - 1, 13) = OutStat.PercentQ3
                    CurWorksheet(.RowCount - 1, 14) = OutStat.Skewness
                    CurWorksheet(.RowCount - 1, 15) = OutStat.Kurtosis
                    CurWorksheet(.RowCount - 1, 16) = OutStat.Sum
                    CurWorksheet(.RowCount - 1, 17) = OutStat.CV
                    CurWorksheet(.RowCount - 1, 18) = OutStat.RMS


                    For x = 0 To ComputeStats_SheetColUpperIndex
                        .Cells(.RowCount - 1, x).Style.Bold = True
                        .Cells(.RowCount - 1, x).Style.FontSize = 8
                    Next


                    If q Mod 100 = 0 Then
                        Application.DoEvents()
                    End If


                Next

                .RowCount += 1

                ToolStrip_Status.Text = "Processing  " +
                                        Format(y + 1, "###,###") +
                                        " of " +
                                        Format(FullPathFiles_UpperBound, "###,###") +
                                        "  : " +
                                        MyFileLocal.Get_OnlyFileName_From_FullFileName(FullPathFiles(y))
                StatusStrip.Refresh()


            Next

            .ResumeUIUpdates()
        End With


        'ReoGrid를 redrawing함
        Me.Width += 1
        Me.Width -= 1

        ToolStrip_Status.Text = "Computing stats completed!"
        StatusStrip.Refresh()


        If CurWorksheet.RowCount = 1 Then
            MsgBox("No data generated." + vbCrLf + "Make sure source files are valid.",
                   MsgBoxStyle.Critical, "Warning")
        Else
            MsgBox("Computing stats completed",
                   MsgBoxStyle.OkOnly, "Compute stats")
        End If
    End Sub


    Private Sub Cmd_Save_Stat_CSV_Click(sender As Object, e As EventArgs) Handles Cmd_Save_Stat_TXTzip.Click
        Static lastUsedFolder As String = ""

        If Grid_DailyStats.CurrentWorksheet(0, 18) Is Nothing Then
            MsgBox("Invalid or empty content", MsgBoxStyle.Critical, "Error")
            Exit Sub
        End If

        If Radio_ComputeStat_Daily.Checked Then
            If ComputeStats_OutTable.Count = 0 Then
                MsgBox("Computuation has not been done yet",
                       MsgBoxStyle.Critical, "Save error")
                Exit Sub
            End If
        End If

        With StatSaveFileDialog
            If lastUsedFolder <> "" Then .InitialDirectory = lastUsedFolder

            .FileName = ""

            .Title = "Save"
            .Filter = MyArchive.FileSaveDialogFilter
            .OverwritePrompt = True
            .CheckPathExists = True

            If .ShowDialog = DialogResult.OK Then
                If Radio_ComputeStat_Daily.Checked Then
                    Save_ComputeStats_OutTableAsFile(ComputeStats_OutTable, .FileName)
                Else
                    Save_GridAsFile(Grid_DailyStats, .FileName)
                End If
                lastUsedFolder = Path.GetDirectoryName(.FileName)
            End If
        End With
    End Sub


    Private Sub Cmd_DeleteDailyStats_Click(sender As Object, e As EventArgs) Handles Cmd_DeleteDailyStats.Click
        FileDDBox_DailyStats.DeleteSelected()
    End Sub

    Private Sub Cmd_ClearListDailyStats_Click(sender As Object, e As EventArgs) Handles Cmd_ClearListDailyStats.Click
        FileDDBox_DailyStats.Clear()
    End Sub


    Private Sub FileDDBox_DailyStats_FilesAdded(FileCount As Integer) Handles FileDDBox_DailyStats.FilesAdded
        If FileCount = 0 Then
            ToolStrip_Status.Text = "No file found!"
        Else
            ToolStrip_Status.Text = "New files added.    Now total " +
                                    Format(FileCount, "###,##0") +
                                    " files"

        End If

        StatusStrip.Refresh()
    End Sub

    Private Sub Radio_ComputeStat_Daily_CheckedChanged(sender As Object, e As EventArgs) _
        Handles Radio_ComputeStat_Daily.CheckedChanged
        Check_TimeWindowAveraging.Visible = Radio_ComputeStat_Daily.Checked
        Combo_TimeWindowAveragingDay.Visible = Radio_ComputeStat_Daily.Checked

        If Radio_ComputeStat_Daily.Checked AndAlso Check_TimeWindowAveraging.Checked Then
            Check_ComputeStat_AnalyzeEveryday.Visible = True
            Combo_TimeWindowAveragingDay.Visible = True
        Else
            Check_ComputeStat_AnalyzeEveryday.Visible = False
            Combo_TimeWindowAveragingDay.Visible = False
        End If
    End Sub


    Private Sub AddAllToComputeStats()
        TabControl_Tools.SelectedTab = Tab_ComputeStat

        Dim AllFiles() As String =
                MyFileLocal.Get_AllFullFileNamesInFolder(Text_TargetExportDataSaveFolder.Text)

        FileDDBox_DailyStats.Clear()
        FileDDBox_DailyStats.Add(AllFiles)
    End Sub


    Private Sub ListView_ExportDataErrors_MouseUp(sender As Object, e As MouseEventArgs) _
        Handles ListView_ExportDataErrors.MouseUp
        ContextMenuListView.Show(ListView_ExportDataErrors, e)
    End Sub


    Private Sub FileDDBox_DailyStats_FileAdding(FileCount As Integer) Handles FileDDBox_DailyStats.FileAdding
        ToolStrip_Status.Text = "Adding " + FileCount.ToString.Trim + "th files"
        StatusStrip.Refresh()
    End Sub



    Private Sub Check_TimeWindowAveraging_CheckedChanged(sender As Object, e As EventArgs) _
        Handles Check_TimeWindowAveraging.CheckedChanged
        If Radio_ComputeStat_Daily.Checked AndAlso Check_TimeWindowAveraging.Checked Then
            Check_ComputeStat_AnalyzeEveryday.Visible = True
            Combo_TimeWindowAveragingDay.Visible = True
        Else
            Check_ComputeStat_AnalyzeEveryday.Visible = False
            Combo_TimeWindowAveragingDay.Visible = False
        End If
    End Sub

    Private Sub Cmd_ComnputeStat_SelectSoureFileFolder_Click(sender As Object, e As EventArgs) _
        Handles Cmd_ComnputeStat_SelectSoureFileFolder.Click
        Static lastUsedFolder As String = ""

        With ComputeStatAddFolderDialog
            If lastUsedFolder <> "" Then .SelectedPath = lastUsedFolder

            If .ShowDialog = DialogResult.OK Then
                lastUsedFolder = .SelectedPath
                Dim AllFiles() As String =
                        MyFileLocal.Get_AllFullFileNamesInFolder(lastUsedFolder)

                FileDDBox_DailyStats.Clear()
                FileDDBox_DailyStats.Add(AllFiles)
            End If
        End With
    End Sub


    Private Sub MyFileLocal_ProcessingMessage(MsgStr As String) Handles MyFileLocal.ProcessingMessage
        ToolStrip_Status.Text = MsgStr
        StatusStrip.Refresh()
    End Sub


    Private Sub MyFileLocal_ProcessingStopped() Handles MyFileLocal.ProcessingStopped
        ToolStrip_Status.Text = "Processing terminated by the user"
        StatusStrip.Refresh()
    End Sub

End Class