﻿Public Class MathLib

    Public Function SortNumberArray(SrcArray As Double()) As Double()
        Array.Sort(SrcArray)
        Return SrcArray
    End Function


    Public Function Compute_Median_Of_UnsortedNumbers(SrcArray As Double()) As Double
        Array.Sort(SrcArray)

        Dim size As Integer = SrcArray.Length
        If size = 0 Then Return 0
        If size Mod 2 = 0 Then
            Return (SrcArray(CInt(size / 2) - 1) + SrcArray(CInt(size / 2))) / 2
        Else
            Return SrcArray(CInt(Math.Floor(size / 2)))
        End If
    End Function



    Public Function Compute_Stdev(ByRef NumberArray As Double(), Mean As Double) As Double
        Dim n As Integer = NumberArray.Length
        Dim variance As Double = Math.Sqrt(NumberArray.Sum(Function(x) (x - Mean) ^ 2) / (n - 1))
        Return variance
    End Function


    Public Function Compute_RMS(ByRef NumberArray As Double()) As Double
        Dim n As Integer = NumberArray.Length

        Dim meanOfSquares As Double = NumberArray.Sum(Function(x) x * x) / n

        Dim rms As Double = Math.Sqrt(meanOfSquares)

        Return rms
    End Function


    Public Function Compute_SumAbsDiff_3rd(ByRef NumberArray As Double(), Mean As Double) As Double
        Dim sumDeviation As Double = 0.0
        Dim upperIndex As Integer = NumberArray.GetUpperBound(0)
        Dim diff As Double


        For i As Integer = 0 To upperIndex
            diff = (NumberArray(i) - Mean)
            sumDeviation += diff ^ 3
        Next

        Return sumDeviation
    End Function

    Public Function Compute_SumAbsDiff_4th(ByRef NumberArray As Double(), Mean As Double) As Double
        Dim sumDeviation As Double = 0.0
        Dim upperIndex As Integer = NumberArray.GetUpperBound(0)
        Dim diff As Double


        For i As Integer = 0 To upperIndex
            diff = (NumberArray(i) - Mean)
            sumDeviation += diff ^ 4
        Next

        Return sumDeviation
    End Function

    Public Function Compute_Skewness(N As Long, Stdev As Double, Stat_SumAbsDiff_3rd As Double) As Double
        'Definited adopted from Excel

        Dim SkewN As Double = Stat_SumAbsDiff_3rd / (Stdev ^ 3)
        Return N / ((N - 1) * (N - 2)) * SkewN
    End Function

    Public Function Compute_Kurtosis(N As Long, Stdev As Double, Stat_SumAbsDiff_4th As Double) As Double
        'Definited adopted from Excel

        Dim KurtN As Double = Stat_SumAbsDiff_4th / (Stdev ^ 4)

        Return N * (N + 1) / ((N - 1) * (N - 2) * (N - 3)) * KurtN - 3 * (N - 1) ^ 2 / ((N - 2) * (N - 3))
    End Function


    Public Function Compute_Percentile_From_SortedNumbers(sequenceSorted As Double(),
                                                          excelPercentile As Double) As Double
        Dim N As Integer = sequenceSorted.Length

        Dim realIndex As Double = (N - 1) * excelPercentile


        If realIndex = 1 Then
            Return sequenceSorted(0)
        ElseIf realIndex = N Then
            Return sequenceSorted(N - 1)
        Else
            Dim index As Integer = Math.Floor(realIndex)
            Dim frac As Double = realIndex - index
            If (index + 1 < N) Then
                Return sequenceSorted(index) * (1 - frac) + sequenceSorted(index + 1) * frac
            Else
                Return sequenceSorted(index)
            End If
        End If
    End Function
End Class
