﻿Imports System.Drawing.Imaging
Imports unvell.ReoGrid


Module MyBas
    Public WithEvents MyFile As New FileSystemEngine
    Public WithEvents MyText As New TextLib
    Public WithEvents MyMath As New MathLib
    Public WithEvents MyTime As New TimeLib
    Public WithEvents MyArchive As New ArchiveUtility


    Public AllowFormCloseToEnd As Boolean = False

    Public Variables_Max As Integer = 5000
    Public DataTable As String()()
    Public DataTableList As New List(Of List(Of String()))(Variables_Max)
    Public DataTableList_Index As Integer
    Public DataTableList_IsValid As Boolean
    Public VariableName As New List(Of String)(Variables_Max)
    Public VariableListIndexDict As New Hashtable(Variables_Max)


    Public LastLogFileName As String = ""
    Public LastLogFileDateStr As New Date



    Public ReadOnly LoRaPorhibitSpecialSymbols() As Char =
                        "~`!@#$%^&*()+=|{}()\':;,<>/?".ToCharArray


    Public Const AnchorStyle_AllDirection As AnchorStyles =
        AnchorStyles.Bottom +
        AnchorStyles.Top +
        AnchorStyles.Right +
        AnchorStyles.Left

    Public Const AnchorStyle_TopBottomLeft As AnchorStyles =
        AnchorStyles.Bottom +
        AnchorStyles.Top +
        AnchorStyles.Left

    Public ParallelCount As Integer
    Public ParallelProgressValue As Integer


    Public Function Convert_ARGB_To_RGB_Bitmap(SourceBitmap As Bitmap) As Bitmap
        Dim bmp As New Bitmap(SourceBitmap.Width,
                              SourceBitmap.Height,
                              PixelFormat.Format24bppRgb)

        Using g As System.Drawing.Graphics = System.Drawing.Graphics.FromImage(bmp)
            g.Clear(Color.White)
            g.DrawImage(SourceBitmap,
                        New Rectangle(New Point(), SourceBitmap.Size),
                        New Rectangle(New Point(), SourceBitmap.Size),
                        GraphicsUnit.Pixel)
        End Using

        Return CType(bmp.Clone, Bitmap)
    End Function


    Public Sub DrawItem(sender As Object, e As DrawItemEventArgs)

        If e.Index <> -1 AndAlso sender.Items(e.Index).ToString().Length >= 1 Then

            If (e.State And DrawItemState.Selected) = DrawItemState.Selected Then
                'e.DrawBackground()
                e.Graphics.FillRectangle(Brushes.Blue, e.Bounds)
                e.Graphics.DrawString(sender.Items(e.Index).ToString(),
                                      e.Font,
                                      Brushes.White,
                                      New PointF(e.Bounds.X, e.Bounds.Y))
                e.DrawFocusRectangle()
            Else
                'e.DrawBackground()
                Dim item As ListItem = sender.Items(e.Index)

                e.Graphics.FillRectangle(New SolidBrush(item.BackColor), e.Bounds)
                e.Graphics.DrawString(sender.Items(e.Index).ToString(),
                                      e.Font,
                                      New SolidBrush(item.ForeColor),
                                      New PointF(e.Bounds.X, e.Bounds.Y))
            End If
        End If
    End Sub




    Public Function Get_TimeDate(SrcStr As String) As String
        If Mid(SrcStr, 12, 1) = "(" AndAlso Mid(SrcStr, 25, 1) = ")" Then
            Dim TempStr As String
            TempStr = Mid(SrcStr, 13, 8).Replace("-", ":")
            TempStr = Left(SrcStr, 11) + TempStr
            Return TempStr
        End If

        Return SrcStr
    End Function


    ' Return String array(row, column)
    Public Function ReadFromExcelSheet(SourceSheet As Worksheet,
                                       ColumnUpperIndex As Integer,
                                       ByRef RowUpperIndex As Integer) As String(,)
        'StatusLabel.Text = "Reading cell values..."
        'Status.Refresh()

        RowUpperIndex = SourceSheet.RowCount - 1
        If SourceSheet(SourceSheet.RowCount - 1, 0) = "" Then
            RowUpperIndex = SourceSheet.RowCount - 2
        End If

        For q As Integer = 0 To SourceSheet.RowCount - 2
            If SourceSheet(q, 0) = "" AndAlso SourceSheet(q + 1, 0) = "" Then
                RowUpperIndex = q - 1
                Exit For
            End If
        Next


        Dim OurArray(RowUpperIndex, ColumnUpperIndex) As String
        For y As Integer = 0 To RowUpperIndex
            For x As Integer = 0 To ColumnUpperIndex
                If SourceSheet(y, x) IsNot Nothing Then
                    OurArray(y, x) = SourceSheet(y, x).ToString.Trim
                End If
            Next
        Next

        'StatusLabel.Text = "Reading cell values has been completed"
        'Status.Refresh()

        Return OurArray
    End Function
End Module


